using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FatCurve
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
            const int numSteps = 1000;
            PointF[] points = new PointF[2*numSteps];
            for (int i = 0; i < numSteps; i++)
            {
                double t = i / (numSteps-1.0);
                PointF p = curve(t);
                double w = width(t);
                const double h = 1e-4;
                PointF p1 = curve(t+h);
                double derivX = (p1.X-p.X)/h;
                double derivY = (p1.Y-p.Y)/h;
                double factor = w*0.5/Math.Sqrt(derivX*derivX+derivY*derivY);
                float ribX = (float)(-derivY*factor);
                float ribY = (float)(derivX * factor);
                PointF pTop = new PointF(p.X+ribX, p.Y+ribY);
                PointF pBottom = new PointF(p.X-ribX, p.Y-ribY);
                points[i] = pTop;
                points[2*numSteps-1-i] = pBottom;
            }

            e.Graphics.FillPolygon(Brushes.Black, points, System.Drawing.Drawing2D.FillMode.Winding);
            //e.Graphics.DrawPolygon(new Pen(Color.Red, 3.0f), points);
        }

        private PointF curve(double t)
        {
            return new PointF(
                    300.0f + 250.0f * (float)(t * Math.Cos(2*5.0 * Math.PI * t * t + 0.05f * trackBar1.Value)),
                    300.0f + 250.0f * (float)(t * Math.Sin(2*5.0 * Math.PI * t))
                );
        }

        private double width(double t)
        {
            return 5.0 - 20.0*t*(t-1.0)*(1.0+Math.Sin(2*Math.PI*t*80));
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            Invalidate();
        }
    }
}